/***********************************************************************/
/*                                                                     */
/*  FILE        :AD9833_drv.c                                          */
/*  DATE        :Tue, Oct 17, 2010                                     */
/*  DESCRIPTION :AD9833 Programmable Waveform Generator Function       */
/*  CPU TYPE    :H8SX/1655                                             */
/*                                                                     */
/*  Created		:Yoshikazu Morita (d:Frontia)                          */
/*  Modified	:													   */
/***********************************************************************/
#include "typedefine.h"
#include "iodefine.h"
#include "AD9833_Drv.h"

#ifdef __cplusplus
extern "C" {
#endif
extern void AD9833_Initalize(void);
#ifdef __cplusplus
}
#endif

//Mf[^̃[vobt@
_UBYTE SendBuf[64];				//AD9833ɂ32rbgi4oCgj̃WX^̂ŁA1oCgMׂ̃obt@
int    posSend;					//̃R}h̊i[CfbNX
int    posSended;				//Mςݓd̊i[CfbNX posSendposSendedƂ̍Mׂf[^
int    bSendFlag;				//MtO


//AD9833pVAʐMW[̏
void AD9833_Initalize(void)
{
	//VAʐMW[(SCI) 1`lڂ𓮍삳B
	MSTP.CRB.BIT._SCI0 	= 0;	//ԂSCI0W[͒~ĂB
	

	// FSYNC|[g̏ 
	P2.DDR = 0x0A;				// P2.1o̓|[gɐ؂ւ
	P2.DR.BIT.B1 = 1;			// FSYNClQ[g (P2.1)
	
	//SCI0̏
	SCI0.SCMR.BYTE = 0xFA;		// MSBt@[Xg X}[gJ[h

	SCI0.SMR.BYTE = 0x83;		// NbN P(24MHz)/64=375kHz=2.666us ȏ㑬FSYNC肳ȂB
	SCI0.SCR.BYTE = 0x01;		// SCKNbN͓NbN
	SCI0.BRR = 0x00;			// 93.75KBps CLK=10.666us
								// FSYNCPrbgڂHIԒɃANeBuƂ鐧䂷ׂɁA
								// TMR7̃NbNƓKvׂɁABRR0ȊOĂ͂sȂB
								
	//TMR7̏
	MSTP._CRC.BIT._TMR67 = 0;	// 8bitTimerjbg3(Timer7)𓮍삳B
	TMR7.TCNT = 0;				// 
	TMR7.TCORA = 0x01;			// PŃRyA}b`B
	TMR7.TCR.BYTE = 0x0A;		// CMIEB/CMIEA=0 RyA}b`A݂𗘗pB
								// OVIE=0 I[o[t[݂͗płȂB 
								// CCLR1/CCLR0=01 RyA}b`AŃNA
								// CKS=3 P/64 (SCI0̃NbNƍ킹j
	TMR7.TCCR.BYTE = 0x00;		// ICK=1       オGbW
	TMR7.TCSR.BYTE = 0x00;		// o͂͂ǂɂȂB
	
	posSend = 0;
	posSended = -1;				// Mς݂Ȃ-1
	bSendFlag = 0;				// MtOZbg 
	
}	

//AD9833 MJn
//MJnB̍ۂɁA10usFSYNCAT[gB
void AD9833_StartSend( void )
{
	_UBYTE data;
	int work;
	posSended = 0;
	data = SendBuf[posSended];

	PA.DR.BIT.B0 = 0;

	// Rg[WX^ 
	SCI0.SCR.BIT.TE = 1;

	work = SCI0.SSR.BIT.TDRE;
	SCI0.SSR.BIT.TDRE = 0;				// ̎_őMJnB
	SCI0.TDR = data;
	work = SCI0.SSR.BIT.TDRE;
	

	SCI0.SCR.BIT.TIE = 1;				// TDRE0ɃNAɊ݂B
	SCI0.SCR.BIT.TEIE = 1;				// TDRE0ɃNAɊ݂B


	// PxStartSendJnAdMJn܂TMR7͑ҋ@B
	TMR7.TCSR.BIT.CMFA =0;				
	TMR7.TCR.BIT.CMIEA =0;

	// MtOON
	bSendFlag = 1;						

	// 10us҂
	WaitTime(1L);
	// ̕ӂFSyncAT[gƁACLKHIԒFSYNCAT[głB
	P2.DR.BIT.B1 = 0;					// FSYNCAT[g
	// 
}

//AD9833 oCgMZbgݏ
//TXI݂Ȁs܂B
void AD9833_NextSendProc( void )
{
	_UBYTE data;

	//posSended́AMς݃f[^Ă
	if( posSended >= 0 )
	{
		//MɊ݂B
		if( posSend-1 > posSended )
		{
			//Mf[^܂cĂB
			//1oCgf[^𑗐MB
			// ̎_ł́A܂1Ô1oCg𑗐MĂŒŁA
			//\ߎ1oCg𑗐Mobt@֐ݒ肵Ă܂B
			//O1oCgMIAIɎ1oCg̑Mp܂B
			data = SendBuf[++posSended];
			SCI0.TDR = data;
			SCI0.SSR.BIT.TDRE = 0;		

			SCI0.SCR.BIT.TIE = 1;				// TDRE0ɃNAɊ݂B
			SCI0.SCR.BIT.TEIE = 1;				// TDRE0ɃNAɊ݂B
		}else{
			//SĂ̑M\̃f[^iSendBuf)Ɋi[Ăf[^𑗐Mobt@֑͂B
			//MR}hobt@ł邱Ƃ`B
			posSended = -1;
			posSend=0;
			SCI0.SCR.BIT.TIE = 0;				// ̏֓銄݂֎~B
		}
		
	}else{
		//Od̍Ō1oCg𑗐Mobt@֊i[A
		//܂AMɁA̓d𑗂ۂɂ́AđM悤ɂ܂B
		//őAMAX_SEND_BUFFoCg܂ŁAđM邱Ƃ\łB
		//߂ĐVd𑗐MJn邪AFSYNC̓AT[ĝ܂܈ێB
		posSended = 0;
		data = SendBuf[posSended];

		// Rg[WX^ 
		SCI0.TDR = data;
		SCI0.SSR.BIT.TDRE = 0;				// ̎_ł͂܂OoCgMB
		SCI0.SCR.BIT.TIE = 1;				// TDRE0ɃNAɊ݂B
		SCI0.SCR.BIT.TEIE = 1;				// TDRE0ɃNAɊ݂B
}
}

//AD9833 MIݏ
//FrameSyncMlQ[g܂B
//
//M݂܂łɁA
//AĎ̃oCg̑M̏ĂȂ
//A̓dIƂ݂ȂďI܂B;;
//
void AD9833_SyncEndProc( void )
{
	P2.DR.BIT.B1 = 1;					// FSYNClQ[g

	SCI0.SCR.BIT.TE = 0;				// M̒~iÔ߁j
	SCI0.SCR.BIT.TEIE = 0;				// ݂̊̏ÎŊ݂֎~B
	

	bSendFlag = 0;
	
}


//AD9833 M
//ʐMobt@ɑMf[^i[B
//[in] sendWord 16bit̑Mf[^
//[ret] G[: -1 :0
//ʐM󋵂ɉāAStartSend́ANextSendProcĂяo܂B
//AM͍őMAX_SEND_BUFFoCgłB
//[vobt@tĂȂ̂ŁAM͍ő呗M܂B
int AD9833_Send( _UWORD sendWord )
{
	_UBYTE upper;
	_UBYTE lower;
	
	if( posSend +1 >= MAX_SEND_BUFF ) 
	{
		return ( -1 );	//Mobt@tɐ܂B ̃G[o鎞ɂ́AMAX_SEND_BUFF̃TCY𑝂₵ĂB
	}
	
	upper = sendWord >> 8;
	lower = sendWord & 0xff;
	
	SendBuf[posSend++] = upper;
	SendBuf[posSend++] = lower;

	if( bSendFlag == 0 )
	{
		//MłȂ΁AMJnȂB
		//TMR7SCI0̓NbNƓ^C~OɂāA
		//SCI0̒ʐMJn^C~OƁANbN𓯊
		//FSYNCM̃AT[g̃^C~OƓNbNHIԂ肳B
		//]TMR7̃^C~OxƁAd𑗂OɎ̓d̑M
		TMR7.TCSR.BIT.CMFA =0;				
		TMR7.TCR.BIT.CMIEA =1;
		PA.DR.BIT.B0 = 1;
		//AD9833_StartSend();
	}else{
		//MȂ̂ŁA̒ʐM̑ɍsB
		if( posSended == -1 )
		{
			//MŁAMς݂Ȃ΁@TXI݂Ȃ̂ŌĂяoKvB
			AD9833_NextSendProc();
		}
	}

	return 0;
}



